#ifndef MOTORLOGIC_HPP
#define MOTORLOGIC_HPP
#include "../mutex.hpp"
#include "../storage/vfs.hpp"
#include "../coreography/coreographer.hpp"
#include <queue>
#include <functional>

struct MotorControl;
class Action;

class MotorLogic {
    MotorControl* motor_control;
    VFS* vfs;
public:
    Mutex* mutex;
    std::queue<Action*>* pending_actions;
    MotorLogic(VFS* vfs, MotorControl* mc);
    void mainloop();
};

#include "../motorcontrol.hpp"
#include "actions.hpp"

#endif