#include "steppers.hpp"

SmartStepper* get_left_stepper(){
    auto* drv = steppings_for(PIN_SERVO_L_DRIVER);
    return new SmartStepper(
        new StepperMotor(new StepperMotorPins(
            drv->at(0),
            PIN_SERVO_L_MICROSTEP_1,
            PIN_SERVO_L_MICROSTEP_2,
            PIN_SERVO_L_MICROSTEP_3,
            PIN_SERVO_L_ENABLE,
            PIN_SERVO_L_STEP,
            PIN_SERVO_L_DIRECTION,
            PIN_SERVO_L_MICROSTEP_DEFAULT,
            PIN_SERVO_L_ENABLE_DEFAULT,
            PIN_SERVO_L_STEP_DEFAULT,
            drv
        )),
        new StepperSensors(new StepperSensorPins(
            PIN_SERVO_POS_L_T,
            PIN_SERVO_POS_L_B
        ))
    );
}

SmartStepper* get_right_stepper(){
    auto* drv = steppings_for(PIN_SERVO_R_DRIVER);
    return new SmartStepper(
        new StepperMotor(new StepperMotorPins(
            drv->at(0),
            PIN_SERVO_R_MICROSTEP_1,
            PIN_SERVO_R_MICROSTEP_2,
            PIN_SERVO_R_MICROSTEP_3,
            PIN_SERVO_R_ENABLE,
            PIN_SERVO_R_STEP,
            PIN_SERVO_R_DIRECTION,
            PIN_SERVO_R_MICROSTEP_DEFAULT,
            PIN_SERVO_R_ENABLE_DEFAULT,
            PIN_SERVO_R_STEP_DEFAULT,
            drv
        )),
        new StepperSensors(new StepperSensorPins(
            PIN_SERVO_POS_R_T,
            PIN_SERVO_POS_R_B
        ))
    );
}
