#ifndef SMARTSTEPPER_HPP
#define SMARTSTEPPER_HPP
#include "steppermotor.hpp"
#include "steppersensors.hpp"

// A stepper that has servo-like properties
class SmartStepper {
protected:
    bool engaged;
    bool engaging;
public:
    StepperSensors* stepper_sensors;
    StepperMotor* stepper_motor;
    SmartStepper(
        StepperMotor* sm,
        StepperSensors* ss
    );

    bool get_engaged();
    bool get_engaging();

    // Target getter/setter
    void set_target(int tgt);
    int get_target();

    // Target GPIO action
    void pursue_calibration();
    void pursue_target();
    bool is_target_reached();

    void reengage();
    void disengage();
    void ensure_engagement();
};

#endif
