#include "steppermotoractuators.hpp"

StepperMotorActuators::StepperMotorActuators(StepperMotorPins* smp){
    this->stepper_motor_pins = smp;
    this->enable = new GPIOOutputPin(smp->enable, smp->enable_compliment);
    this->step = new GPIOOutputPin(smp->step, smp->step_compliment);
    this->direction = new GPIOOutputPin(smp->direction, false);
    this->microstep = new std::vector<GPIOOutputPin*>();
    bool microstep_compliment = smp->microstep_compliment;
    for(uint8_t i=0; i<smp->microstep_level; i++){
        int8_t microstep_pin = smp->microstep[i];
        GPIOOutputPin* gpio_pin = new GPIOOutputPin(microstep_pin, microstep_compliment);
        gpio_pin->bind();
        this->microstep->push_back(gpio_pin);
    }
    this->enable->bind();
    this->step->bind();
    this->direction->bind();
}
