#include "steppersensors.hpp"

StepperSensors::StepperSensors(StepperSensorPins* ssp){
    this->stepper_sensors_listeners = new StepperSensorListeners(ssp);
}

bool StepperSensors::get_top_state(){return this->stepper_sensors_listeners->top->read();}
bool StepperSensors::get_bottom_state(){return this->stepper_sensors_listeners->bottom->read();}
bool StepperSensors::is_in_equilibrium(){
    bool t = this->get_top_state();
    bool b = this->get_bottom_state();
    return t==b;
}
