#ifndef STORAGE_NVS_HPP
#define STORAGE_NVS_HPP

#include <math.h>
#include <stdint.h>
#include <string>
#include <string.h>
#include <vector>
#include "nvs.h"
#include "nvs_flash.h"
#include "esp_spiffs.h"
#include "esp_system.h"
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "Arduino.h"
#include "../utils/array.hpp"


class NVS{
protected:
    const char* namespc;
    nvs_handle handle = 0;
public:
    NVS();

    Array<char>* get_string(std::string location);
    Array<uint8_t>* get_blob(std::string location);
    int get_int(std::string location, int failure=0);
    long get_long(std::string location, long failure=0);
    double get_float(std::string location, double failure=NAN);

    void set_string(std::string location, std::string text);
    void set_blob(std::string location, Array<uint8_t>* blob);
    void set_int(std::string location, int value);
    void set_long(std::string location, long value);
    void set_float(std::string location, double value);

    void rm(std::string location);
};

#endif
